\documentclass[a4paper]{article}
\usepackage[english]{babel}
\usepackage[T1]{fontenc}
\usepackage{graphicx}
\usepackage[a4paper, top=0.75cm, bottom=0.75cm, left=2cm, right=2cm]{geometry}
\usepackage{listings}
\usepackage{inconsolata}
\pagenumbering{gobble}
\lstset{frame=single, showstringspaces=false, columns=fixed, basicstyle={\ttfamily}, commentstyle={\it}, numbers=left, tabsize=4}
\begin{document}
\lstset{title=Contents of \texttt{README}}
\lstset{
  language=,
  morekeywords={NAME, SYNOPSIS, DESCRIPTION, NOTES, EXAMPLES, AUTHOR, COPYRIGHT},
  moredelim=[is][\it]{<|}{|>},
  moredelim=[is][\bf]{<:}{:>}
}
\begin{lstlisting}
NAME
        <:bingraph:> - a library for generating ASCII-art of the binomial
        distribution function.

SYNOPSIS
            void <:testBinGraph:>(<|BinGraph|> *bin);
        Uses the <:randm:> library to simulate the tests with the specified
        probability, thus estimating the value of the binomial distribution.

            char *<:drawGraph:>(<|BinGraph|> *bin);
        Generates an ASCII-image for the graph. String stored in dynamic memory.

            char *<:getGraphString:>(unsigned n, double p);
        Returns the ASCII-image for the binomial distribution function with the
        specified number of tests and probability of success.

DESCRIPTION
        <:bingraph:> uses an `include-based` theme selection system, the user
        should include a theme file <:*before*:> including the <:bingraph:> library.

        5 default themes are available in src/themes:
            ascii_plot, ascii_cadre, plot, cadre, wide

        The user can also create a custom theme. The requirements for a valid
        theme are:
            - Export the following symbols, initiated with appropriate values
                - const char **<:points:>;
                    An array of pointers to strings, each string defines a
                    symbol representing a point on the graph.
                    Symbols range from "points located low in the block"
                    to "points located high in the block"
                - const char *<:above:>;
                    A string symbol, representing a block above the point.
                - const char *<:below:>;
                    A string symbol, representing a block below the point.
                - const unsigned <:maxchar:>;
                    Maximum number of chars in a symbol in this theme.
                - const unsigned <:pointopts:>;
                    The number of symbols in the points array.
                - const char *<:frame_:><|XY|>;
                    The symbol, used for drawing the frame.
                    (<|X|> is one of u - upper, c - center, b - bottom)
                    (<|Y|> is one of l - left, c - center, r - right)
                    Except for <:frame_cc:>, which may not be defined.


NOTES
        The `symbols` in this file refer to a sequence of chars, although this
        is not strictly required, in general all symbols in a theme should have
        the same display width. For example, all symbols in the default themes
        have display width of 1, with the exception of `wide`, which has
        display width of 2.

EXAMPLES
        Examples are available in src/examples.c

AUTHOR
        Implemented by Stotskii Andrey (ruro).

COPYRIGHT
        Copyright (c) 2017 Free Software Foundation, Inc.  License GPLv3+:
        GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>.
        This is free software: you are free to change and redistribute it.
        There is NO WARRANTY, to the extent permitted by law.
\end{lstlisting}
\newpage
\lstset{title=Contents of \texttt{makefile}}
\lstset{language={[gnu]make}}
\begin{lstlisting}
CFLAGS=-g -Wall -O3 -lm -std=gnu99
CC=gcc

vpath %.c src
vpath %.h src

examples: bingraph.o randm.o
bingraph.o: bingraph.h randm.h
randm.o: randm.h

.PHONY:libs
libs: randm.o bingraph.o

.PHONY:clean
clean:
	rm -f *.o examples
\end{lstlisting}
\lstset{language={[ANSI]C}}
\lstset{literate={float.}{float.}6}
\lstset{morekeywords={BinGraph, size_t}}
\lstset{title=Contents of \texttt{src/bingraph.h}}
\begin{lstlisting}
#ifndef _BINGRAPH_H // INCLUDE GUARD
#define _BINGRAPH_H

// Number of iterations performed for approximation.
#define STD_BIN_ITER 1 << 20

// Height of graph in chars.
#define STD_GRPH_H 40

// Height multiplier.
#define STD_GRPH_MULT 4

// See the theme files for instructions, on how to use themes.
#ifndef _THEME
#error Please import a theme file!
#endif

// Theme exports.
const char **points;
const char *above;
const char *below;
const unsigned maxchar;
const unsigned pointopts;
const char *frame_ul;
const char *frame_uc;
const char *frame_ur;
const char *frame_cr;
const char *frame_br;
const char *frame_bc;
const char *frame_bl;
const char *frame_cl;

// Binomial graph structure.
typedef struct
{
    unsigned trials_num;
    unsigned iterations_num;
    double success_prob;
    double results[];
} BinGraph;

void testBinGraph(BinGraph *);
char *drawGraph(BinGraph *);
char *getGraphString(unsigned, double);

#endif // INCLUDE GUARD 
\end{lstlisting}
\newpage
\lstset{title=Contents of \texttt{src/bingraph.c}}
\begin{lstlisting}
#include <stdio.h>
#include <string.h>

#define _THEME -1
#include "bingraph.h"
#include "randm.h"

char *getGraphString(unsigned trials, double success)
{
    BinGraph *bin = NULL;
    if (!trials || success > 1.0 || success < 0.0)
        return NULL;

    size_t size = sizeof(*bin) + sizeof(bin->results[0])*(trials+1);
    bin = malloc(size);
    if (!bin)
        return NULL; 

    memset(bin, 0, size);
    bin->success_prob = success;
    bin->trials_num = trials;
    bin->iterations_num = STD_BIN_ITER;

    testBinGraph(bin);
    char *str = drawGraph(bin);
    free(bin);

    return str;
}

void testBinGraph(BinGraph *bin)
{
    unsigned trials = bin->trials_num;
    unsigned iterations = bin->iterations_num;
    double success = bin->success_prob;
    double step = (double)STD_GRPH_MULT/iterations;
    unsigned accum = 0;

    for (unsigned i = 0; i < iterations; i++)
    {
        for (unsigned j = 0; j < trials; j++)
             accum += (randd_f() < success);

        bin->results[accum] += step;
        accum = 0;
    }
}

const char *getPointSymbol(double val)
{
    val *= pointopts;
    ssize_t idx = (int) val;
    if (idx >= 0 && idx < pointopts)
        return points[idx];
    else
        return points[0];
}

#define append(symbol)                                          \
    do {                                                        \
        snprintf(str + i, size - i, "%s%n", symbol, &tmp);      \
        i += tmp;                                               \
    } while(0)

\end{lstlisting}
\newpage
\begin{lstlisting}[firstnumber=last]
char *drawGraph(BinGraph *bin)
{
    size_t i = 0;
    int tmp = 0;
    char *str = NULL;
    const double step = (double)1/STD_GRPH_H;
    unsigned trials = bin->trials_num;
    size_t size = (maxchar) * (STD_GRPH_H + 2) * (trials + 4) + 1;

    // STD_GRPH_H rows of data.
    // trials     columns of data.
    // +2         rows of formatting.
    // +2         columns of formatting.  (+1 '\n')
    // Each symbol is maxchar bytes wide. (+1 '\0')
    str = malloc(size);
    if (!str)
        return NULL;


    // Print upper part of graph frame. 
    append(frame_ul);
    for (unsigned col = 0; col <= trials; col++)
        append(frame_uc);
    append(frame_ur);
    append("\n");

    // Print the middle rows.
    for (unsigned row = 0; row < STD_GRPH_H; row++)
    {
        append(frame_cl);
        // Print the data for this row.
        double high = 1 - row*step;
        double low  = 1 - (row + 1)*step;
        for (unsigned col = 0; col <= trials; col++)
        {
            double res = bin->results[col];
            if (res > high)
                append(below); // symbol is *below* the point
            else if (res < low)
                append(above); // symbol is *above* the point
            else 
                append(getPointSymbol((res-low)/step));
        }
        append(frame_cr);
        append("\n");
    }

    // Print bottom part of graph frame. 
    append(frame_bl);
    for (unsigned col = 0; col <= trials; col++)
        append(frame_bc);
    append(frame_br);
    append("\n");

    return str;
}
\end{lstlisting}
\newpage
\lstset{title=Contents of \texttt{src/examples.c}}
\begin{lstlisting}
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

// Try with any one of these lines uncommented
#include "themes/wide.h"
//#include "themes/plot.h"
//#include "themes/cadre.h"
//#include "themes/ascii_plot.h"
//#include "themes/ascii_cadre.h"

#include "bingraph.h"

int main(void)
{
    srand(time(NULL));
    for (int i = 1; i < 4; i++)
    {
        char *str = getGraphString(75, 0.25*i);
        printf("%s\n", str);
        free(str);
    }
}
\end{lstlisting}
ASCII Cadre
\centering
\lstset{title=Contents of \texttt{src/themes/ascii\textunderscore cadre.h}}
\begin{lstlisting}
#ifdef _THEME
#error Only 1 theme allowed.
#else
#define _THEME

// Array of strings, representing the points on the graph.
// The symbols used for displaying a point on a graph.
// If more than one symbol is defined, it is interpreted as different symbols,
// for points ranging from "less than a full symbol" to "full symbol".
const char *pts[] = // ['*']
{
    "#"
};

// above is the string for symbols placed *above* the actual point.
// below is the string for symbols placed *below* the actual point.
const char *above = " "; // ' '
const char *below = " "; // ' '

// The maximum number of chars one "symbol" uses in this theme.
const unsigned maxchar = 1;

// Array of strings, representing the frame of the graph.
const char *frame_ul = "/";     // Upper-Left       '/'
const char *frame_uc = "-";     // Upper-Center     '-'
const char *frame_ur = "\\";    // Upper-Right      '\'
const char *frame_cr = "|";     // Center-Right     '|'
const char *frame_br = "/";     // Bottom-Right     '/'
const char *frame_bc = "-";     // Bottom-Center    '-'
const char *frame_bl = "\\";    // Bottom-Left      '\'
const char *frame_cl = "|";     // Center-Left      '|'

// Keep the next 2 lines unchanged, exports for the points array.
const unsigned pointopts = sizeof(pts)/sizeof(*pts);
const char **points = pts;

#endif
\end{lstlisting}
\newpage
\lstset{title=Contents of \texttt{src/themes/cadre.h}}
\begin{lstlisting}
#ifdef _THEME
#error Only 1 theme allowed.
#else
#define _THEME

// Array of strings, representing the points on the graph.
// The symbols used for displaying a point on a graph.
// If more than one symbol is defined, it is interpreted as different symbols,
// for points ranging from "less than a full symbol" to "full symbol".
const char *pts[] =
{
    "\xe2\x97\x8f"
};

// above is the string for symbols placed *above* the actual point.
// below is the string for symbols placed *below* the actual point.
const char *above = " ";
const char *below = " ";

// The maximum number of chars one "symbol" uses in this theme.
const unsigned maxchar = 3;

// Array of strings, representing the frame of the graph.
const char *frame_ul = "\xe2\x95\xad";  // Upper-Left
const char *frame_uc = "\xe2\x94\x80";  // Upper-Center
const char *frame_ur = "\xe2\x95\xae";  // Upper-Right
const char *frame_cr = "\xe2\x94\x82";  // Center-Right
const char *frame_br = "\xe2\x95\xaf";  // Bottom-Right
const char *frame_bc = "\xe2\x94\x80";  // Bottom-Center
const char *frame_bl = "\xe2\x95\xb0";  // Bottom-Left
const char *frame_cl = "\xe2\x94\x82";  // Center-Left

// Keep the next 2 lines unchanged, exports for the points array.
const unsigned pointopts = sizeof(pts)/sizeof(*pts);
const char **points = pts;

#endif
\end{lstlisting}
\newpage
\lstset{title=Contents of \texttt{src/themes/plot.h}}
\begin{lstlisting}
#ifdef _THEME
#error Only 1 theme allowed.
#else
#define _THEME

// Array of strings, representing the points on the graph.
// The symbols used for displaying a point on a graph.
// If more than one symbol is defined, it is interpreted as different symbols,
// for points ranging from "less than a full symbol" to "full symbol".
const char *pts[] =
{
    "\xe2\x96\x81",
    "\xe2\x96\x82",
    "\xe2\x96\x83",
    "\xe2\x96\x84",
    "\xe2\x96\x85",
    "\xe2\x96\x86",
    "\xe2\x96\x87",
    "\xe2\x96\x88"
};

const char **points = pts;

// above is the string for symbols placed *above* the actual point.
// below is the string for symbols placed *below* the actual point.
const char *above = " ";
const char *below = "\xe2\x96\x88";

// The maximum number of chars one "symbol" uses in this theme.
const unsigned maxchar = 3;

// Keep this line unchanged, exports the number of available point options.
const unsigned pointopts = sizeof(pts)/sizeof(*pts);

// Array of strings, representing the frame of the graph.
const char *frame_ul = "\xe2\x96\xb2";  // Upper-Left
const char *frame_uc = " ";             // Upper-Center
const char *frame_ur = " ";             // Upper-Right
const char *frame_cr = " ";             // Center-Right
const char *frame_br = "\xe2\x96\xb6";  // Bottom-Right
const char *frame_bc = "\xe2\x95\x90";  // Bottom-Center
const char *frame_bl = "\xe2\x95\xac";  // Bottom-Left
const char *frame_cl = "\xe2\x95\x91";  // Center-Left

#endif
\end{lstlisting}
\newpage
\lstset{title=Contents of \texttt{src/themes/ascii\textunderscore plot.h}}
\begin{lstlisting}
#ifdef _THEME
#error Only 1 theme allowed.
#else
#define _THEME

// Array of strings, representing the points on the graph.
// The symbols used for displaying a point on a graph.
// If more than one symbol is defined, it is interpreted as different symbols,
// for points ranging from "less than a full symbol" to "full symbol".
const char *pts[] = // ['.','_','-','=']
{
    ".",
    "_",
    "-",
    "="
};

const char **points = pts;

// above is the string for symbols placed *above* the actual point.
// below is the string for symbols placed *below* the actual point.
const char *above = " "; // ' '
const char *below = "*"; // '*'

// The maximum number of chars one "symbol" uses in this theme.
const unsigned maxchar = 1;

// Keep this line unchanged, exports the number of available point options.
const unsigned pointopts = sizeof(pts)/sizeof(*pts);

// Array of strings, representing the frame of the graph.
const char *frame_ul = "^"; // Upper-Left       '^'
const char *frame_uc = " "; // Upper-Center     ' '
const char *frame_ur = " "; // Upper-Right      ' '
const char *frame_cr = " "; // Center-Right     ' '
const char *frame_br = ">"; // Bottom-Right     '>'
const char *frame_bc = "-"; // Bottom-Center    '-'
const char *frame_bl = "+"; // Bottom-Left      '+'
const char *frame_cl = "|"; // Center-Left      '|'

#endif
\end{lstlisting}
\newpage
\lstset{title=Contents of \texttt{src/themes/wide.h}}
\begin{lstlisting}
#ifdef _THEME
#error Only 1 theme allowed.
#else
#define _THEME

// Array of strings, representing the points on the graph.
// The symbols used for displaying a point on a graph.
// If more than one symbol is defined, it is interpreted as different symbols,
// for points ranging from "less than a full symbol" to "full symbol".
const char *pts[] =
{
    "\xe2\x96\x81\xe2\x96\x81",
    "\xe2\x96\x82\xe2\x96\x82",
    "\xe2\x96\x83\xe2\x96\x83",
    "\xe2\x96\x84\xe2\x96\x84",
    "\xe2\x96\x85\xe2\x96\x85",
    "\xe2\x96\x86\xe2\x96\x86",
    "\xe2\x96\x87\xe2\x96\x87",
    "\xe2\x96\x88\xe2\x96\x88"
};

const char **points = pts;

// above is the string for symbols placed *above* the actual point.
// below is the string for symbols placed *below* the actual point.
const char *above = "  ";
const char *below = "\xe2\x96\x88\xe2\x96\x88";

// The maximum number of chars one "symbol" uses in this theme.
const unsigned maxchar = 6;

// Keep this line unchanged, exports the number of available point options.
const unsigned pointopts = sizeof(pts)/sizeof(*pts);

// Array of strings, representing the frame of the graph.
const char *frame_ul = "\xe2\x96\xb2 ";             // Upper-Left
const char *frame_uc = "  ";                        // Upper-Center
const char *frame_ur = "  ";                        // Upper-Right
const char *frame_cr = "  ";                        // Center-Right
const char *frame_br = "\xe2\x95\x90\xe2\x96\xb6";  // Bottom-Right
const char *frame_bc = "\xe2\x95\x90\xe2\x95\x90";  // Bottom-Center
const char *frame_bl = "\xe2\x95\xac\xe2\x95\x90";  // Bottom-Left
const char *frame_cl = "\xe2\x95\x91 ";             // Center-Left

#endif
\end{lstlisting}
\newpage
Wide Plot
\centering
\includegraphics[width=\textwidth]{img/graph_wide_25.png}
Cadre
\centering
\includegraphics[width=\textwidth]{img/graph_cadre_50.png}
\newpage
ASCII Plot
\centering
\includegraphics[width=\textwidth]{img/graph_ascii_plot_75.png}
\end{document}
